function init()

	Pos1A = FindLocation("1A")
	Pos2A = FindLocation("2A")

	Pos1B = FindLocation("1B")
	Pos2B = FindLocation("2B")

	Snd = LoadLoop("MOD/main/plane/plane.ogg")

	broken = false

	canbreak = true

	spawnTable = {
		"MOD/main/plane/prefabs/Blue_plane.xml",
		"MOD/main/plane/prefabs/Grey_plane.xml",
		"MOD/main/plane/prefabs/Red_plane.xml"
	}

	pick = true

	explode = true

	flythroughs_last = 0
	flythroughs = 1

	FireTime = 0

end

function tick(dt)

	PlaneBody = FindBody("PB")
	PlaneShape = FindShape("plane")

	PlaneBodyT = GetBodyTransform(PlaneBody)
	PlaneShapeT = GetShapeWorldTransform(PlaneShape)

	Pos1TA = GetLocationTransform(Pos1A)
	Pos2TA = GetLocationTransform(Pos2A)

	Pos1TB = GetLocationTransform(Pos1B)
	Pos2TB = GetLocationTransform(Pos2B)

	if pick == true then
		randomSpawnIndex = math.random(1, 3)
		randomRouteIndex = math.random(1, 2)
		pick = false
	end

	if broken == false and IsHandleValid(PlaneBody) == true then
		trail()
		PlayLoop(Snd, PlaneBodyT.pos, 0.25)
		SetBodyDynamic(PlaneBody, false)
	end


	if canbreak == false then
		broken = false
		canbreak = true
	end

	if pick == false then
		if randomRouteIndex == 1 then
			travel1()
		end

		if randomRouteIndex == 2 then
			travel2()
		end
	end

	if canbreak == true then
		if IsShapeBroken(PlaneShape) == true then
			broken = true
			canbreak = false
			SetBodyDynamic(PlaneBody, true)

			SetBodyAngularVelocity(PlaneBody, Vec(0, 0, 5))
			ApplyBodyImpulse(PlaneBody, PlaneBodyT.pos, QuatRotateVec(PlaneBodyT.rot, Vec(0, 0, -600)))

			QueryRejectBody(PlaneBody)
			QueryRejectShape(PlaneShape)

			local hit, point, normal, shape = QueryClosestPoint(PlaneShapeT.pos, 0.7)

			--DebugCross(point, 1, 0, 0, 1)
			--DebugWatch('hitpoint', point)

			if hit == true and GetShapeVoxelCount(shape) > 100 and explode == true then
				Explosion(PlaneShapeT.pos, 1)
				explode = false
			end

			RemoveTag(PlaneBody, "PB")
			pick = true
			smoke()


			FireTime = FireTime + dt
			if FireTime > 5 then
				RemoveTag(PlaneShape, "plane")
				explode = true
				FireTime = 0
			end
		end
	end

	--DebugCross(point, 1, 0, 0, 1)
	--DebugWatch('hitpoint', point)
	--DebugWatch('explode', explode)
	--DebugWatch("PlanePos", GetBodyTransform(PlaneBody))
	--DebugWatch("pick", pick)
	--DebugWatch("randomRouteIndex", randomRouteIndex)
	--DebugWatch("randomSpawnIndex", randomSpawnIndex)
	--DebugWatch("PlaneActualPos", PlaneBodyT.pos)
	--DebugWatch("validEntity", IsHandleValid(PlaneBody))
	--DebugWatch("broken", broken)
	--DebugWatch("canbreak", canbreak)
	--DebugWatch("IsShapeBroken(PlaneShape)", IsShapeBroken(PlaneShape))

end

function travel1()

    local fraction = GetTime()/65
    local flythroughs = math.floor(fraction)
    fraction = fraction%1
    if flythroughs > flythroughs_last then
        flythroughs_last = flythroughs
        if IsShapeBroken(PlaneShape) == false then
        	Delete(PlaneBody)
        end
        PlaneBody = Spawn(spawnTable[randomSpawnIndex], Pos1TA)[1]
        pick = true
    end

	local pos = VecLerp(Pos1TA.pos, Pos2TA.pos, fraction)
	local rot = QuatLookAt(PlaneBodyT.pos, Pos2TA.pos)

	SetBodyTransform(PlaneBody, Transform(pos, rot))

	--DebugWatch("fraction", fraction)

end

function travel2()

    local fraction = GetTime()/65
    local flythroughs = math.floor(fraction)
    fraction = fraction%1
    if flythroughs > flythroughs_last then
        flythroughs_last = flythroughs
        if IsShapeBroken(PlaneShape) == false then
        	Delete(PlaneBody)
        end
        PlaneBody = Spawn(spawnTable[randomSpawnIndex], Pos1TB)[1]
        pick = true
    end

	local pos = VecLerp(Pos1TB.pos, Pos2TB.pos, fraction)
	local rot = QuatLookAt(PlaneBodyT.pos, Pos2TB.pos)

	SetBodyTransform(PlaneBody, Transform(pos, rot))

	--DebugWatch("fraction", fraction)

end

function smoke()
	SpawnFire(GetShapeWorldTransform(PlaneShape).pos)

	ParticleType("smoke")
	ParticleColor(0.4, 0.4, 0.4)
	ParticleCollide(0)
	ParticleGravity(0.2)
	ParticleRadius(0.05, 0.3)
	ParticleStretch(1.0)
	SpawnParticle(GetShapeWorldTransform(PlaneShape).pos, Vec(0, 0.01, 0), 1.2)

	ParticleType("plain")
	ParticleColor(1.0, 0.2, 0.05)
	ParticleCollide(0)
	ParticleGravity(0.5)
	ParticleRadius(0.3, 0.05)
	ParticleStretch(1.0)
	ParticleEmissive(5)
	SpawnParticle(GetShapeWorldTransform(PlaneShape).pos, Vec(0, 0.01, 0), 0.4)
end

function trail()
	ParticleType("smoke")
	ParticleColor(1.0, 1.0, 1.0)
	ParticleCollide(0)
	ParticleAlpha(0.6, 0.0)
	ParticleRadius(0.05, 0.3)
	ParticleStretch(1.0)
	SpawnParticle(PlaneBodyT.pos, Vec(0, 0, 0), 10.0)
end