local function hsl_to_rgb(hue, saturation, lightness)
	-- https://en.wikipedia.org/wiki/HSL_and_HSV#To_RGB
	hue = hue % 360
	local chroma = (1-math.abs(2*lightness-1))*saturation
	hue = hue/60
	local x = chroma*(1-math.abs((hue % 2)-1))
	local red, green, blue
	if hue < 1 then
		red, green, blue = chroma, x, 0
	elseif hue < 2 then
		red, green, blue = x, chroma, 0
	elseif hue < 3 then
		red, green, blue = 0, chroma, x
	elseif hue < 4 then
		red, green, blue = 0, x, chroma
	elseif hue < 5 then
		red, green, blue = x, 0, chroma
	else
		red, green, blue = chroma, 0, x
	end
	local m = lightness-chroma/2
	return red+m, green+m, blue+m
end
function init()
	lights = FindLights("hue")
end
function tick()
	for i=1, #lights do
	local light = lights[i]
		local h, s, l = (GetTime()*90)%360, 1, 0.5
		local r, g, b = hsl_to_rgb(h, s, l)
		SetLightColor(light, r, g, b)
		--DebugWatch("h", h)
		--DebugWatch("s", s)
		--DebugWatch("l", l)
		--DebugWatch("r", r)
		--DebugWatch("g", g)
		--DebugWatch("b", b)
	end
end